#!/usr/bin/perl 
#     This is a very simple program that scans your Apache log file
#   and looks for hosts that have attempted to exploit your system
#   with the cmd.exe exploit multiple times. The reason I wrote this
#   is because I'm sick of those pesky cmd lines showing up in my log.
#   
#     You can either set this program to run automatically through cron
#   by setting the $autoipt variable to "ON" or leave it off and scan
#   manually using the available options.
#
#     I don't suggest modifying the code unless you know what you're doing.
#  If you have any suggestions please feel free to e-mail me. Oh, and I 
#  don't take responsibility if you end up firewalling yourself out of your 
#  system. So all in all.. enjoy. 
#
#  Note: This program can take a few moments depending on how big your log
#    file is so please be patient
#
#  V2.4
#  Author:  node
#  Contact: node@node.newcon.org
#  Site:    http://node.newcon.org
#  irc:     irc.chatnet.org
#  Date:    03/19/2004

use Socket;
use Getopt::Std;
getopts("ab:sct:i:o:m:w:zh", \%args);

$apachefile = "/var/log/apache/access_log";
$outlogfile = "/var/log/cmdblocker";
$iptpath = "/usr/sbin/iptables";
$devlist = "/proc/net/dev";
$prog = "cmd.exe";
$idev = "eth0";
$dport = 80;
$maxhit = 20;
$autoipt = "OFF";

if (defined $args{m}) {$maxhit = $args{m};}
if (defined $args{i}) {$apachelogfile = $arges{i};}
if (defined $args{w}) {$idev = $args{w};}

# Verify Settings
&verifyset();

# Scan but don't add
if ($args{s}) {
  &parselog();
  &printlist();
  exit(0);
}  

# Remove all hosts
if ($args{c}) {
  &parselog();
  &getiptable();
  &cleaript();
  exit(0);
} 

# Rem single host
if ($args{t}) {
  &getiptable();
  chomp($args{t});
  remhost($args{t});
  exit(0);
} 

# Add all hosts
if ($autoipt eq "ON" || $args{a}) {
  &parselog();
  &getiptable();
  &addallipt();
  exit(0);
}

# Add single host
if ($args{b}) {
  &getiptable();
  chomp($args{b});
  addhost($args{b});
  exit(0);
}
 
# Print iptable ruleset
if ($args{z}) {
  system("$iptpath -L");
  exit(0);
}

# Print help
if ($args{h}) {
  &printhelp();
  exit(0);
}

&printhelp();

sub verifyset {
  if ($autoipt eq "OFF") {
    if (!defined %args) {
      &printhelp();
      exit(0);
    }
  }

  $whoami = `/usr/bin/whoami`;
  chomp($whoami);
  if ($whoami ne "root") {
    print "To run this program you are requiered to be root\n";
    exit(0);
  }

  if ($autoipt ne "ON" && $autoipt ne "OFF") {
    print "\$autoipt has not been set correctly. Change to either \"ON\" or \"OFF\"\n";
    exit(0);
  }

  if (-e $apachefile) {
    # Good to go
  } else {
    print "Apache log file could not be located at $apachefile\n";
    exit(0);
  }

  if (-e $iptpath) {
    # Good to go
  } else {
    print "iptables could not be found at $iptpath\n";
    exit(0);
  }  
   
  if (-e $devlist) {
    @dev = `cat $devlist`;
    $devsize = @dev;
    for ($a=0;$a<=$devsize;$a++) {
      $_ = $dev[$a];
      ($devcheck) = (split)[0];
      ($devcheck, $null) = split(/:/, $devcheck);
      if ($idev eq $devcheck) {
        # Good to go
        $a = $devsize;
      } elsif ($a == $devsize) {
        print "Device $idev could not be found\n";
        exit(0);
      }
    }
  }
}

sub parselog {
  open (FILE, "$apachefile") || die "[$apachefile] $!\n";
  while (<FILE>) {
    if ($_ =~ /$prog/) {
      ($host) = (split)[0];
      ipcheck($host);
    } 
  }
  close(FILE);

  # Resolve list
  $asize = @temp;
  for ($h=0;$h<=$asize;$h+=2) {
    if ($temp[$h] =~ /(\d){1,3}\.(\d){1,3}\.(\d){1,3}\.(\d){1,3}/) {
      if ($temp[$h] =~ /[a-zA-Z]/) {
        # Do nothing
      } else {
        my $ip = $temp[$h];
        $temp[$h] = gethostbyaddr(inet_aton($temp[$h]), AF_INET)         
                      or $temp[$h] = $ip;
 
        # Check for copies
        if ($temp[$h] =~ /[a-zA-Z]/) {
          for($a=0;$a<=$asize;$a+=2) {
            if ($h == $a) {
              # Do nothing
            } else {
              if ($temp[$a] eq $temp[$h]) {
                $temp[$h+1] = $temp[$h+1] + $temp[$a+1];
                splice(@temp, $a, 2);
                $asize = @temp;
              }
            }
          }
        }
      }
    }
  }

  # Sort list
  $asize = @temp;
  until ($asize == 0) {
    $sortsize = @sorted;
    $asize = @temp;
    if ($sortsize == 0) { 
      push(@sorted, $temp[0], $temp[1]);
      shift(@temp);
      shift(@temp);
    } else {
      $asize = @temp;
      $sortsize = @sorted;
      for ($k=0;$k<=$sortsize;$k+=2) {
        if ($temp[1] >= $sorted[$k+1]) {
          if ($k == 0) {
            splice(@sorted, 0, 0, $temp[0], $temp[1]);
          } else {
            splice(@sorted, $k, 0, $temp[0], $temp[1]);
          }
          shift(@temp);
          shift(@temp);
          $k = $sortsize;
        }
      }
    } 
  }
}

sub ipcheck {
  $asize = @temp;
  if ($asize == 0) {
    push (@temp, $_[0]);
    push (@temp, 1);
    $mem = $_[0];
  } else {
    for ($i=0;$i<=$asize;$i+=2) {
      if ($_[0] eq $temp[$i]) {
        if ($_[0] eq $mem) {
          last;
        } else {
          $temp[$i+1]++;
          last;
        }
      } elsif ($i == $asize) {
        push (@temp, $_[0]);
        push (@temp, 1);
        $mem = $_[0];
      }
    }
  }
}

sub getiptable {
  @iptable = `$iptpath -L`;
  # Take the headers off the table
  shift(@iptable);
  shift(@iptable);
}
  
sub addallipt {
  $tablesize = @iptable;
  $sortsize = @sorted;
  if ($autoipt eq "OFF") {
    # Don't open  
  } else {  
    open(OUTFILE, ">>$outlogfile") || die "[$outlogfile] $!\n";
  }
  for ($l=0;$l<=$sortsize-1;$l+=2) {
    if ($sorted[$l+1] >= $maxhit) {
      for ($m=0;$m<=$tablesize;$m++) {
        $_ = $iptable[$m];
        ($host) = (split)[3];
      if ($sorted[$l] eq $host) {
          # Found a host
          $m = $tablesize;
        } elsif ($_ eq "\n") {
          system("$iptpath -A INPUT -i $idev -s $sorted[$l] -p tcp --destination-port $dport -j DROP");
          if ($autoipt eq "OFF") {
            # Don't log
          } else {
            $time = (localtime);
            chomp($time);
            print OUTFILE "$time :-> $sorted[$l]\n";
          }
          $m = $tablesize;
        }
      }
    } 
  }
  close(OUTFILE);
}

sub cleaript {
  $tablesize = @iptable;
  $sortsize = @sorted;
  for ($n=0;$n<=$sortsize;$n+=2) {
    for ($o=0;$o<=$tablesize;$o++) {
      $_ = $iptable[$o];
      ($host) = (split)[3];
      if ($iptable[$o] eq "\n") {
        $o = $tablesize;
      } elsif ($sorted[$n] eq $host) {
        $num = $o+1;
        `$iptpath -D INPUT $num`;
        print "Removed $host\n";
        splice(@iptable, $o, 1);
      } else {
        # Do nothing
      }
    }
  }
}

sub addhost {
  if ($_[0] =~ /[a-zA-Z0-9]/) {
    $tablesize = @iptable;
    for ($w=0;$w<=$tablesize;$w++) {
      $_ = $iptable[$w];
      ($host) = (split)[3];
      if ($host eq $_[0]) {
        print "$_[0] already added.\n";
        exit(0); 
      } elsif ($iptable[$w] eq "") {
        system("$iptpath -A INPUT -i $idev -s $_[0] -p tcp --destination-port $dport -j DROP");
        print "Added host $_[0]\n";
        $w = $tablesize;
      }
    }
  }
}

sub remhost {
  if ($args{t} =~ /[a-zA-Z0-9]/) {
    $tablesize = @iptable;
    for ($v=0;$v<=$tablesize;$v++) {
      $_ = $iptable[$v];
      ($host) = (split)[3];
      if ($host eq $_[0]) {
        $num = $v+1;
        `$iptpath -D INPUT $num`;
        print "Removed $_[0]\n";
        $v = $tablesize;
      } elsif ($iptable[$v] eq "") {
        print "$_[0] not found\n";
        exit(0);
      } else {
        # Do nothing
      }
    }
  }
}

sub printlist {
  $sortsize = @sorted;
  if ($args{o}) {
    open(OUTFILE, ">$args{o}") || die "[$args{o}] $!\n";
    print OUTFILE "Num Host\n";
  }
  print "Num Host\n";
  for ($l=0;$l<=$sortsize-1;$l+=2) {
    if ($sorted[$l+1] >= $maxhit) {
      if ($args{o}) {
        print OUTFILE "$sorted[$l+1]  $sorted[$l]\n";
      } else {
        print "$sorted[$l+1]  $sorted[$l]\n";
      }
    }
  }
  if ($args{o}) {
    close(OUTFILE);
  }
}

sub printhelp {
  print qq~
Usage: $0 [opt..] (see below for examples)
    -a Auto-adds hosts to iptable ruleset           $0 -a
    -b Add individual host to iptable ruleset       $0 -b host.blah.org
    -s Perform scan and output results              $0 -s

    -c Remove all hosts from iptable ruleset        $0 -c
    -t Remove individual host from iptable ruleset  $0 -b host.blah.org

    -i Scan alternate Apache logfile                $0 -i /var/log/www/access_log
    -o Output results to a file (-s only)           $0 -s -o /home/james/cmdlog -m 10
    -m Change the max number of requests            $0 -s -m 15
    -w Change network interface	device		    $0 -s -w eth1
    -z Print current iptable ruleset		    $0 -z
    -h Print this help

~; exit;
}

